/*-
 * ~~~~~~licensing~~~~~~
 * blueprint-generator
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.blueprint.generator;

import freemarker.template.TemplateException;
import ru.entaxy.esb.system.common.exception.TemplateNotFound;

import java.io.IOException;
import java.net.URL;
import java.util.Map;

public interface BlueprintGenerator {

    Blueprint createBlueprint(URL templateUrl, String templateName, String systemName, Map<String, String> params)
            throws TemplateNotFound, TemplateException, IOException;

    Blueprint createBlueprint(String templateName, String systemName, Map<String, String> params)
            throws TemplateNotFound, TemplateException, IOException;
}
